Package com.sas.metadata.remote

# Interface PropertyGroup

All Superinterfaces:
  `CMetadata`, `LocalizedType`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface PropertyGroup extends LocalizedType
Represents a group of properties. The properties that are part of this group are associated using the GroupedProperties association.

Attributes of PropertyGroup are:

- `IsVisible`
- `Minimum`
- `Maximum`

Associations of PropertyGroup are:

- `AssociatedObject`
- `Customizers`
- `ParentGroup`
- `GroupedProperties`
- `SubpropertyGroups`

## Usage

To create an instance of this PropertyGroup, use the `factory` create methods.
Example: create a PropertyGroup with name "PropertyGroup_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PropertyGroup myObject = (PropertyGroup) factory.createComplexMetadataObject(objectStore, "PropertyGroup_Object", MetadataObjects.PROPERTYGROUP, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDOBJECT_NAME`
  Constant used for the name of the AssociatedObject association.
  `static final String`
  `ASSOCIATION_CUSTOMIZERS_NAME`
  Constant used for the name of the Customizers association.
  `static final String`
  `ASSOCIATION_GROUPEDPROPERTIES_NAME`
  Constant used for the name of the GroupedProperties association.
  `static final String`
  `ASSOCIATION_PARENTGROUP_NAME`
  Constant used for the name of the ParentGroup association.
  `static final String`
  `ASSOCIATION_SUBPROPERTYGROUPS_NAME`
  Constant used for the name of the SubpropertyGroups association.
  `static final String`
  `ATTRIBUTE_ISVISIBLE_NAME`
  Constant used for the name of the IsVisible attribute.
  `static final String`
  `ATTRIBUTE_MAXIMUM_NAME`
  Constant used for the name of the Maximum attribute.
  `static final String`
  `ATTRIBUTE_MINIMUM_NAME`
  Constant used for the name of the Minimum attribute.

  ### Fields inherited from interface com.sas.metadata.remote.LocalizedType

  `ASSOCIATION_RESOURCES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Root`
  `getAssociatedObject()`
  Gets the `Root` for `AssociatedObject`
  `AssociationList`
  `getAssociatedObjects()`
  Gets the AssociationList of `AssociatedObjects`
  `AssociationList`
  `getAssociatedObjects(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedObjects`
  `AssociationList`
  `getCustomizers()`
  Gets the AssociationList of `Customizers`
  `AssociationList`
  `getCustomizers(boolean fGoToServer)`
  Gets the Associationlist of `Customizers`
  `AssociationList`
  `getGroupedProperties()`
  Gets the Association list of `GroupedProperties`
  `AssociationList`
  `getGroupedProperties(boolean fGoToServer)`
  Gets the Associationlist of `GroupedProperties`
  `int`
  `getIsVisible()`
  Gets the `int` value of `IsVisible`
  `int`
  `getIsVisibleState()`
  Gets the Metadata State of `IsVisible`
  `int`
  `getMaximum()`
  Gets the `int` value of `Maximum`
  `int`
  `getMaximumState()`
  Gets the Metadata State of `Maximum`
  `int`
  `getMinimum()`
  Gets the `int` value of `Minimum`
  `int`
  `getMinimumState()`
  Gets the Metadata State of `Minimum`
  `PropertyGroup`
  `getParentGroup()`
  Gets the `PropertyGroup` for `ParentGroup`
  `AssociationList`
  `getParentGroups()`
  Gets the AssociationList of `ParentGroups`
  `AssociationList`
  `getParentGroups(boolean fGoToServer)`
  Gets the Associationlist of `ParentGroups`
  `AssociationList`
  `getSubpropertyGroups()`
  Gets the Association list of `SubpropertyGroups`
  `AssociationList`
  `getSubpropertyGroups(boolean fGoToServer)`
  Gets the Associationlist of `SubpropertyGroups`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedObject`
  `Customizers`
  `ParentGroup`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedObject(Root inObject)`
  Sets the `AssociatedObjects` list 0th element to be `inObject`.
  `void`
  `setAssociatedObjects(AssociationList list)`
  Sets the `AssociatedObjects` list to be `list`.
  `void`
  `setAssociatedObjects(AssociationList list, int state)`
  Sets the `AssociatedObjects` list to be `list`.
  `void`
  `setCustomizers(AssociationList list)`
  Sets the `Customizers` list to be `list`.
  `void`
  `setCustomizers(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setGroupedProperties(AssociationList list)`
  Sets the `GroupedProperties` list to be `list`.
  `void`
  `setGroupedProperties(AssociationList inObjects, int state)`
  Sets the entire GroupedProperties list to match the passed in AssociationList, sets the state of the GroupedProperties
  `void`
  `setIsVisible(int inIsVisible)`
  Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsVisible(int inIsVisible, int state)`
  Sets the `IsVisible` Metadata State.
  `void`
  `setIsVisible(String inIsVisible)`
  Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsVisible(String inIsVisible, int state)`
  Sets the `IsVisible` value and Metadata State.
  `void`
  `setIsVisibleState(int state)`
  Sets the Metadata State of `IsVisible`.
  `void`
  `setMaximum(int inMaximum)`
  Sets the `Maximum` value and sets the state to MetadataState.LOCAL.
  `void`
  `setMaximum(int inMaximum, int state)`
  Sets the `Maximum` Metadata State.
  `void`
  `setMaximum(String inMaximum)`
  Sets the `Maximum` value and sets the state to MetadataState.LOCAL.
  `void`
  `setMaximum(String inMaximum, int state)`
  Sets the `Maximum` value and Metadata State.
  `void`
  `setMaximumState(int state)`
  Sets the Metadata State of `Maximum`.
  `void`
  `setMinimum(int inMinimum)`
  Sets the `Minimum` value and sets the state to MetadataState.LOCAL.
  `void`
  `setMinimum(int inMinimum, int state)`
  Sets the `Minimum` Metadata State.
  `void`
  `setMinimum(String inMinimum)`
  Sets the `Minimum` value and sets the state to MetadataState.LOCAL.
  `void`
  `setMinimum(String inMinimum, int state)`
  Sets the `Minimum` value and Metadata State.
  `void`
  `setMinimumState(int state)`
  Sets the Metadata State of `Minimum`.
  `void`
  `setParentGroup(PropertyGroup inObject)`
  Sets the `ParentGroups` list 0th element to be `inObject`.
  `void`
  `setParentGroups(AssociationList list)`
  Sets the `ParentGroups` list to be `list`.
  `void`
  `setParentGroups(AssociationList list, int state)`
  Sets the `ParentGroups` list to be `list`.
  `void`
  `setSubpropertyGroups(AssociationList list)`
  Sets the `SubpropertyGroups` list to be `list`.
  `void`
  `setSubpropertyGroups(AssociationList inObjects, int state)`
  Sets the entire SubpropertyGroups list to match the passed in AssociationList, sets the state of the SubpropertyGroups

  ### Methods inherited from interface com.sas.metadata.remote.LocalizedType

  `getResources, getResources, setResources, setResources`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_ISVISIBLE_NAME

    static final String ATTRIBUTE_ISVISIBLE_NAME
    Constant used for the name of the IsVisible attribute.

    IsVisible: Should this property be displayed in a UI?

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_MINIMUM_NAME

    static final String ATTRIBUTE_MINIMUM_NAME
    Constant used for the name of the Minimum attribute.

    Minimum: This is an optional attribute that describes the minimum number of property objects in this group that must have values.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_MAXIMUM_NAME

    static final String ATTRIBUTE_MAXIMUM_NAME
    Constant used for the name of the Maximum attribute.

    Maximum: This is an optional attribute that describes the maximum number of property objects in this group that may have settings.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDOBJECT_NAME

    static final String ASSOCIATION_ASSOCIATEDOBJECT_NAME
    Constant used for the name of the AssociatedObject association.

    AssociatedObject: The object that uses this group of properties.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_CUSTOMIZERS_NAME

    static final String ASSOCIATION_CUSTOMIZERS_NAME
    Constant used for the name of the Customizers association.

    Customizers: The programs that customizes this property group.A customizer is a standalone editor used to customize or edit a value. It does not reside inside a UI element as an editor does, but defines it's own window. If none exists on the entity, the customizer of the property type is returned.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PARENTGROUP_NAME

    static final String ASSOCIATION_PARENTGROUP_NAME
    Constant used for the name of the ParentGroup association.

    ParentGroup: The parent group for this group of properties.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_GROUPEDPROPERTIES_NAME

    static final String ASSOCIATION_GROUPEDPROPERTIES_NAME
    Constant used for the name of the GroupedProperties association.

    GroupedProperties: The properties in this group.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SUBPROPERTYGROUPS_NAME

    static final String ASSOCIATION_SUBPROPERTYGROUPS_NAME
    Constant used for the name of the SubpropertyGroups association.

    SubpropertyGroups: The subgroups for this group of properties.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `LocalizedType`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `AssociatedObject`
    `Customizers`
    `ParentGroup`
    Specified by:
      `initializePredObjects` in interface `LocalizedType`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsVisible

    int getIsVisible() throws RemoteException
    Gets the `int` value of `IsVisible`
    Returns:
      The `IsVisible`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsVisibleState

    int getIsVisibleState() throws RemoteException
    Gets the Metadata State of `IsVisible`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMinimum

    int getMinimum() throws RemoteException
    Gets the `int` value of `Minimum`
    Returns:
      The `Minimum`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMinimumState

    int getMinimumState() throws RemoteException
    Gets the Metadata State of `Minimum`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMaximum

    int getMaximum() throws RemoteException
    Gets the `int` value of `Maximum`
    Returns:
      The `Maximum`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMaximumState

    int getMaximumState() throws RemoteException
    Gets the Metadata State of `Maximum`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedObjects`
    Returns:
      Returns the AssociationList of `AssociatedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedObject

    Root getAssociatedObject() throws RemoteException, MdException
    Gets the `Root` for `AssociatedObject`
    Returns:
      The `Root` ( `null` if not set) of `AssociatedObject`which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCustomizers

    AssociationList getCustomizers() throws RemoteException, MdException
    Gets the AssociationList of `Customizers`
    Returns:
      Returns the AssociationList of `Customizers` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getParentGroups

    AssociationList getParentGroups() throws RemoteException, MdException
    Gets the AssociationList of `ParentGroups`
    Returns:
      Returns the AssociationList of `ParentGroups` which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getParentGroup

    PropertyGroup getParentGroup() throws RemoteException, MdException
    Gets the `PropertyGroup` for `ParentGroup`
    Returns:
      The `PropertyGroup` ( `null` if not set) of `ParentGroup`which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getGroupedProperties

    AssociationList getGroupedProperties() throws RemoteException, MdException
    Gets the Association list of `GroupedProperties`
    Returns:
      The AssociationList of `GroupedProperties` which can be of type:
      AbstractProperty
      Property
      PrototypeProperty
      AttributeProperty
      AssociationProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSubpropertyGroups

    AssociationList getSubpropertyGroups() throws RemoteException, MdException
    Gets the Association list of `SubpropertyGroups`
    Returns:
      The AssociationList of `SubpropertyGroups` which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCustomizers

    AssociationList getCustomizers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Customizers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Customizers` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getParentGroups

    AssociationList getParentGroups(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ParentGroups`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `ParentGroups` which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getGroupedProperties

    AssociationList getGroupedProperties(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `GroupedProperties`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `GroupedProperties` which can be of type:
      AbstractProperty
      Property
      PrototypeProperty
      AttributeProperty
      AssociationProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSubpropertyGroups

    AssociationList getSubpropertyGroups(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SubpropertyGroups`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `SubpropertyGroups` which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setIsVisible

    void setIsVisible(int inIsVisible) throws RemoteException
    Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsVisible` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisible

    void setIsVisible(int inIsVisible, int state) throws RemoteException
    Sets the `IsVisible` Metadata State.
    Parameters:
      `inIsVisible` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisible

    void setIsVisible(String inIsVisible) throws RemoteException
    Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsVisible` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisible

    void setIsVisible(String inIsVisible, int state) throws RemoteException
    Sets the `IsVisible` value and Metadata State.
    Parameters:
      `inIsVisible` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisibleState

    void setIsVisibleState(int state) throws RemoteException
    Sets the Metadata State of `IsVisible`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMinimum

    void setMinimum(int inMinimum) throws RemoteException
    Sets the `Minimum` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inMinimum` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMinimum

    void setMinimum(int inMinimum, int state) throws RemoteException
    Sets the `Minimum` Metadata State.
    Parameters:
      `inMinimum` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMinimum

    void setMinimum(String inMinimum) throws RemoteException
    Sets the `Minimum` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inMinimum` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMinimum

    void setMinimum(String inMinimum, int state) throws RemoteException
    Sets the `Minimum` value and Metadata State.
    Parameters:
      `inMinimum` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMinimumState

    void setMinimumState(int state) throws RemoteException
    Sets the Metadata State of `Minimum`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMaximum

    void setMaximum(int inMaximum) throws RemoteException
    Sets the `Maximum` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inMaximum` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMaximum

    void setMaximum(int inMaximum, int state) throws RemoteException
    Sets the `Maximum` Metadata State.
    Parameters:
      `inMaximum` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMaximum

    void setMaximum(String inMaximum) throws RemoteException
    Sets the `Maximum` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inMaximum` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMaximum

    void setMaximum(String inMaximum, int state) throws RemoteException
    Sets the `Maximum` value and Metadata State.
    Parameters:
      `inMaximum` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMaximumState

    void setMaximumState(int state) throws RemoteException
    Sets the Metadata State of `Maximum`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObjects

    void setAssociatedObjects(AssociationList list) throws RemoteException
    Sets the `AssociatedObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObjects

    void setAssociatedObjects(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObject

    void setAssociatedObject(Root inObject) throws RemoteException
    Sets the `AssociatedObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCustomizers

    void setCustomizers(AssociationList list) throws RemoteException
    Sets the `Customizers` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCustomizers

    void setCustomizers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setParentGroups

    void setParentGroups(AssociationList list) throws RemoteException
    Sets the `ParentGroups` list to be `list`. Object of which can be of type:
    PropertyGroup
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setParentGroups

    void setParentGroups(AssociationList list, int state) throws RemoteException
    Sets the `ParentGroups` list to be `list`. Object of which can be of type:
    PropertyGroup
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setParentGroup

    void setParentGroup(PropertyGroup inObject) throws RemoteException
    Sets the `ParentGroups` list 0th element to be `inObject`.
    Parameters:
      `inObject` - PropertyGroup
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setGroupedProperties

    void setGroupedProperties(AssociationList list) throws RemoteException
    Sets the `GroupedProperties` list to be `list`. Objects of which can be of type:
    AbstractProperty
    Property
    PrototypeProperty
    AttributeProperty
    AssociationProperty
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setGroupedProperties

    void setGroupedProperties(AssociationList inObjects, int state) throws RemoteException
    Sets the entire GroupedProperties list to match the passed in AssociationList, sets the state of the GroupedProperties
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSubpropertyGroups

    void setSubpropertyGroups(AssociationList list) throws RemoteException
    Sets the `SubpropertyGroups` list to be `list`. Objects of which can be of type:
    PropertyGroup
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSubpropertyGroups

    void setSubpropertyGroups(AssociationList inObjects, int state) throws RemoteException
    Sets the entire SubpropertyGroups list to match the passed in AssociationList, sets the state of the SubpropertyGroups
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.